#
# Copyright 2020 by Delphix
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

#
# This class has been automatically generated from:
#     /delphix-certificate-config.json
#
# Do not edit this file manually!
#

from __future__ import unicode_literals

from delphixpy.v1_9_2.web.objects.TypedObject import TypedObject
from delphixpy.v1_9_2 import common

class __Undef(object):
    def __repr__(self):
        return "undef"

    def __setattr__(self, name, value):
        raise Exception('Cannot modify attributes of __Undef.')

_UNDEFINED = __Undef()

try:
    TEXT_TYPE = unicode
except NameError:
    TEXT_TYPE = str

class CertificateConfig(TypedObject):
    """
    *(extends* :py:class:`v1_9_2.web.vo.TypedObject` *)* Configuration for the
    use of custom CA signed certificates.
    """
    def __init__(self, undef_enabled=True):
        super(CertificateConfig, self).__init__()
        self._type = ("CertificateConfig", True)
        self._validate_windows_connector_certificate = (self.__undef__, True)

    API_VERSION = "1.9.2"

    @classmethod
    def from_dict(cls, data, dirty=False, undef_enabled=True):
        obj = super(CertificateConfig, cls).from_dict(data, dirty, undef_enabled)
        obj._validate_windows_connector_certificate = (data.get("validateWindowsConnectorCertificate", obj.__undef__), dirty)
        if obj._validate_windows_connector_certificate[0] is not None and obj._validate_windows_connector_certificate[0] is not obj.__undef__:
            assert isinstance(obj._validate_windows_connector_certificate[0], bool), ("Expected one of ['boolean'], but got %s of type %s" % (obj._validate_windows_connector_certificate[0], type(obj._validate_windows_connector_certificate[0])))
            common.validate_format(obj._validate_windows_connector_certificate[0], "None", None, None)
        return obj

    def to_dict(self, dirty=False, belongs_to_parent=False):
        dct = super(CertificateConfig, self).to_dict(dirty, belongs_to_parent)

        def dictify(obj, prop_is_list_or_vo=False):
            if isinstance(obj, list):
                return [dictify(o, prop_is_list_or_vo) for o in obj]
            elif hasattr(obj, "to_dict"):
                return obj.to_dict(dirty=dirty, belongs_to_parent=prop_is_list_or_vo)
            else:
                return obj
        if "validate_windows_connector_certificate" == "type" or (self.validate_windows_connector_certificate is not self.__undef__ and (not (dirty and not self._validate_windows_connector_certificate[1]) or isinstance(self.validate_windows_connector_certificate, list) or belongs_to_parent)):
            dct["validateWindowsConnectorCertificate"] = dictify(self.validate_windows_connector_certificate)
        return dct

    def dirty(self):
        return self.from_dict(self.to_dict(dirty=False), dirty=True)

    def force_dirty(self):
        self._validate_windows_connector_certificate = (self._validate_windows_connector_certificate[0], True)

    def is_dirty(self):
        return any([self._validate_windows_connector_certificate[1]])

    def __eq__(self, other):
        if other is None:
            return False
        if not isinstance(other, CertificateConfig):
            return False
        return super(CertificateConfig, self).__eq__(other) and \
               self.validate_windows_connector_certificate == other.validate_windows_connector_certificate

    def __ne__(self, other):
        return not self.__eq__(other)

    def __hash__(self):
        return id(self)

    def __repr__(self):
        return common.generate_repr_string(self)

    @property
    def validate_windows_connector_certificate(self):
        """
        Whether or not the engine will validate custom Windows Connector
        certificates.

        :rtype: ``bool``
        """
        return self._validate_windows_connector_certificate[0]

    @validate_windows_connector_certificate.setter
    def validate_windows_connector_certificate(self, value):
        self._validate_windows_connector_certificate = (value, True)

